package dcworms.schedframe.scheduling.utils;

import java.io.StringReader;

import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ResolverException;
import org.exolab.castor.xml.Unmarshaller;
import org.exolab.castor.xml.ValidationException;
import org.exolab.castor.xml.XMLContext;

import schedframe.DescriptionContainer;

public class ApplicationProfileDescription implements DescriptionContainer<org.qcg.broker.schemas.jobdesc.Task>{

	private static final long serialVersionUID = 7853990656207447619L;
	protected static Unmarshaller unmarshaller;
	static {
		XMLContext context = new XMLContext();
		try {
			context.addClass(org.qcg.broker.schemas.jobdesc.Job.class);
			unmarshaller = context.createUnmarshaller();
		} catch (ResolverException e) {
			e.printStackTrace();
			unmarshaller = null;
		}
	}
	
	protected String xml;
	protected org.qcg.broker.schemas.jobdesc.Job app;
	
	public ApplicationProfileDescription(String xmlJobDesc){
		xml = xmlJobDesc;
	}


	public org.qcg.broker.schemas.jobdesc.Task getDescription() {
		if(app == null){
			try {
				app = (org.qcg.broker.schemas.jobdesc.Job) unmarshaller.unmarshal(new StringReader(xml));
			} catch (MarshalException e) {
				e.printStackTrace();
			} catch (ValidationException e) {
				e.printStackTrace();
			}
		}
		return app.getTask(0);
	}

	public String getDocument() throws Exception {
		return xml;
	}

}
