package example.energy;

import schedframe.resources.computing.ComputingNode;
import schedframe.resources.computing.Processor;
import schedframe.resources.computing.profiles.energy.EnergyEvent;
import schedframe.resources.devices.Device;
import schedframe.resources.devices.PhysicalResource;
import schedframe.scheduling.manager.tasks.JobRegistry;

public class NodeEnergyEstimationPlugin extends BaseEnergyEstimationPlugin {

	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
			PhysicalResource resource) {
		double powerConsumption = 0;
		ComputingNode node = (ComputingNode) resource;
		for(Processor cpu: node.getProcessors()){
			try{
				powerConsumption = powerConsumption + cpu.getPowerInterface().getRecentPowerUsage().getValue();
			} catch (Exception e){
				
			}
		}
		try {
			powerConsumption = powerConsumption + node.getPowerInterface().getPowerConsumption(node.getPowerInterface().getPowerState());
			for(Device dev: node.getResourceCharacteristic().getDevices()){
				powerConsumption = powerConsumption + dev.getPowerInterface().getRecentPowerUsage().getValue();
			}
		} catch (NoSuchFieldException e) {
		}

		return powerConsumption;
	}

}
