package simulator.stats.implementation;

import schedframe.resources.ResourceType;
import simulator.stats.implementation.out.StatsSerializer;

public class ResourceAirFlowStats extends ResourceDynamicStats implements StatsInterface{

	protected double sumValue;
	
	private String[] headers = { "resourceName", "timestamp", "airFlow" };
	
	public ResourceAirFlowStats (String resourceName, ResourceType resourceType, String usageType) {
		super(resourceName, resourceType, usageType);
		if(usageType == null){
			this.usageType = "airflow_volume";
		}
	}

	public void setSumValue(double sumValue) {
		this.sumValue = sumValue;
	}

	public double getSumValue() {
		return sumValue;
	}
	
	public Object serialize(StatsSerializer serializer) {
		return serializer.visit(this);
	}

	public String[] getHeaders() {
		return headers;
	}

}
